/* CHAP04.H  (Header file for "Menus a la Carte") */

/* Functions in order of appearance */

   int PASCAL WinMain(HANDLE, HANDLE, LPSTR, int);
   long FAR PASCAL WindowProcedure(HWND, unsigned, WORD, LONG);
   long FAR PASCAL PopupProcedure(HWND, unsigned, WORD, LONG);
   long FAR PASCAL Pinup2Procedure(HWND, unsigned, WORD, LONG);
   BOOL FAR PASCAL About(HWND, unsigned, WORD, LONG);

/* Window setup routines */

   BOOL InitODwin(HANDLE);
   HWND CreateODwindow(HANDLE, int);

/* System menu routines */

   WORD AppendSMitem(HWND, LPSTR);
   WORD InsertSMitem(HWND, WORD, LPSTR);
   BOOL DeleteSMitem(HWND, WORD);
   void DeleteSMseps(HWND);

/* Bitmap menu routines */

   BOOL LoadBMitem(HWND, WORD, LPSTR);
   HBITMAP LoadBMcheck(HWND, LPSTR);
   void SetBMcheck(HWND, WORD, int, HBITMAP, HBITMAP);

/* Dynamic menu routines */

   HMENU LoadDM(HWND, LPSTR);
   WORD AppendDMitem(HMENU, LPSTR);
   BOOL DeleteDMitem(HMENU, WORD);

/* Popup and pinup menu routines */

   void AdjustPMcursor(HWND, WORD, LONG);
   BOOL InitPMpinup1(VOID);
   BOOL InitPMpinup2(VOID);
   BOOL MovePMpinup(HWND, unsigned);
   HWND ShowPMpinup1(HWND);
   HWND ShowPMpinup2(HWND);
   BOOL ShowPMfloat(HWND, LONG);


/* User menu routines */

   void CheckUMon(HWND, WORD);
   void CheckUMoff(HWND, WORD);
   void CheckUMonoff(HWND, int, WORD);
   void CheckUMtoggle(HWND, int, WORD);
   void GrayUMoff(HWND, WORD);
   void GrayUMon(HWND, WORD);
   void GrayUMonoff(HWND, int, WORD);
   void GrayUMtoggle(HWND, int, WORD);
   HMENU ChangeUMall(HWND, LPSTR);


/* Miscellaneous routines */

   int DisplayMBinfo(HWND, int, LPSTR);
   BOOL ProcessWMcommand(HWND, WORD);
   void AdjustWINcursor(HWND);
   void SetWINfocus(HWND);


/* Global variables and defines*/

   DWORD dwStyle = WS_OVERLAPPEDWINDOW;
   DWORD dwStylePopup = WS_POPUP | WS_CAPTION | WS_SYSMENU;
   HANDLE hInst;
   #define MAXITEMS 25
   int arrayID[MAXITEMS];
   int idTotal;


/* Miscellaneous identifiers */

   #define IDM_SYSMENUITEM     200
   #define IDM_DYNAMIC         300

   #define IDM_BEGIN           250
   #define IDM_END            2000

   #define IDM_ABOUT           401
   #define IDM_ABOUTBM         402
   #define IDM_TEST            403
   #define IDM_DUMMY           404


/* IDs for POPUP statement items */

   #define IDP_ROU              0
   #define IDP_DEMA             1
   #define IDP_DEMB             2
   #define IDP_BMA              3
   #define IDP_USE              4
   #define IDP_SYS              5
   #define IDP_DYN              6
   #define IDP_PIN              7


/* Menu item identifiers */

   #define IDM_CHANGEUMALL     501
   #define IDM_RESTOREUMALL    502
   #define IDM_APPENDSMITEM    511
   #define IDM_INSERTSMITEM    512
   #define IDM_DELETESMITEM    513
   #define IDM_DELETESMSEPS    514
   #define IDM_LOADDM          520
   #define IDM_APPENDDMITEM    521
   #define IDM_DELETEDMITEM    522
   #define IDM_PINUPOPEN1      530
   #define IDM_PINUPCLOSE1     531
   #define IDM_PINUPOPEN2      532
   #define IDM_PINUPCLOSE2     533

   #define IDM_DEMOA1          601
   #define IDM_DEMOA2          602
   #define IDM_DEMOA3          603
   #define IDM_DEMOA4          604
   #define IDM_DEMOA5          605

   #define IDM_DEMOB1          611
   #define IDM_DEMOB2          612
   #define IDM_DEMOB3          613
   #define IDM_DEMOB4          614
   #define IDM_DEMOB5          615

   #define IDM_OPTIONS         800
   #define IDM_COPY            801
   #define IDM_CUT             802
   #define IDM_PASTE           803

   #define IDM_CREATEMISC      901
   #define IDM_EDITMISC        902
   #define IDM_DRAWMISC        903
   #define IDM_FINDMISC        904
   #define IDM_COPYMISC        905
   #define IDM_VERIFYMISC      906





